---
title: HTMLCanvasElement.mozGetAsFile()
slug: Web/API/HTMLCanvasElement/mozGetAsFile
tags:
  - API
  - Canvas
  - Firefox
  - HTMLCanvasElement
  - Method
  - Mozilla
  - Non-standard
  - Obsolete
  - Reference
  - mozGetAsFile
---
<div>
<div>
<div>{{APIRef("Canvas API")}}</div>
</div>
{{non-standard_header}}</div>

<p>The non-standard, Firefox-specific the {{domxref("HTMLCanvasElement")}} method {{domxref("HTMLCanvasElement.mozGetAsFile", "mozGetAsFile()")}} returns a memory-based {{domxref("File")}} object representing the image contained in the canvas.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var><em>canvas</em>.mozGetAsFile(<em>name</em>, <em>type</em>);</var>
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>name</code></dt>
 <dd>A {{domxref("DOMString")}} indicating the file name to give the file representing the image file in memory.</dd>
 <dt><code>type</code> {{optional_inline}}</dt>
 <dd>A {{domxref("DOMString")}} which specifies the image file format to use when creating the new image file. The default type is <code>image/png</code>. For other options, see our <a href="/en-US/docs/Web/Media/Formats/Image_types">Image file type and format guide</a>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("File")}} object representing the image contained in the canvas. The file's data is entirely located in memory until such time as it is explicitly written to disk.</p>

<h2 id="Examples">Examples</h2>

<div>
<p>This example creates an image file from the {{HTMLElement("canvas")}} element on the page, then uses a {{domxref("FileReader")}} to read the image data from the file.</p>

<h3 id="HTML">HTML</h3>

<pre class="brush: html">&lt;canvas id="canvas" width="100" height="100"&gt;&lt;/canvas&gt;
&lt;p&gt;&lt;a href="#" id="link"&gt;Click here to try out mozGetAsFile()&lt;/a&gt;.&lt;/p&gt;</pre>

<h3 id="JavaScript">JavaScript</h3>

<p>The following code uses <code>mozGetAsFile()</code> to create a {{domxref("File")}} object from the canvas and appends it as an image to the page by loading it as a data URL using the {{domxref("FileReader.readAsDataURL", "readAsDataURL()")}} method. Then a new {{HTMLElement("img")}} element is created using the new data URL.</p>

<pre class="brush: js;highlight:[17]">function draw() {
  var canvas = document.getElementById('canvas');
  var ctx = canvas.getContext('2d');

  ctx.fillStyle = 'rgb(200, 0, 0)';
  ctx.fillRect(10, 10, 55, 50);

  ctx.fillStyle = 'rgba(0, 0, 200, 0.5)';
  ctx.fillRect(30, 30, 55, 50);

  var link = document.getElementById('link');
  link.addEventListener('click', copy);
}

function copy() {
  var canvas = document.getElementById('canvas');
  var f = canvas.mozGetAsFile('test.png');
  var reader = new FileReader();
  reader.readAsDataURL(f);

  reader.onloadend = function() {
   var newImg = document.createElement('img');
   newImg.src = reader.result;
   document.body.appendChild(newImg);
  }
}

window.addEventListener('load', draw);</pre>
</div>

<h2 id="Specifications">Specifications</h2>

<p>Not part of any specification.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.HTMLCanvasElement.mozGetAsFile")}}</p>
